#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "dialog1.h"
#include "preis.h"
#include "qlabel.h"
#include "qradiobutton.h"
#include <QStackedWidget>
#include <QWidget>
#include "paymentprocessor.h"
#include <QTimer>
#include "simu.h"

QT_BEGIN_NAMESPACE
namespace Ui {
class MainWindow;
}
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
     explicit MainWindow(QWidget *parent = nullptr);

    ~MainWindow();

private slots:
    void on_pushButton_clicked();
    void handleDialog1();

    void on_bestaetigen_2_clicked();

    void on_pushButton_2_clicked();
    //für paymentprocessor
    void on_radioButtonCard_toggled(bool checked);
    void on_radioButtonCash_toggled(bool checked);
    void on_cardButton_clicked();
    void on_cashButton_clicked();
    void updatePaidAmount(double amount);
    void showPaymentSuccessMessage();
    //ende paymentprocessor


    void on_pushButton_7_clicked();

    //zubereitung
    void on_buttonSelectRamen_clicked();
    void on_buttonSelectSauce_clicked();
    void on_buttonConfirmSelection_clicked();
    void updateLabels();

    void checkCashBalance(); // Neuer Slot
    void clearCashBalance();

    //simulation
    void on_startSimulationButton_clicked();


 //   void on_buttonCash5_clicked();

    void on_pushButton_3_clicked();

    void on_pushButton_4_clicked();

    void updateChangeLabel();

private:
    Ui::MainWindow *ui;
    Dialog1 *secondwindow;
    QRadioButton *radiobutton;
    PaymentProcessor *paymentProcessor;
    Ramenart selectedRamen;
    Soßeart selectedSauce;
    GeldscheinTyp selectedGeldschein;
    Preis *preis;



};
#endif // MAINWINDOW_H
