#include "tst_unittest_kasse.h"
#include <QtTest>

void KasseTest::initTestCase() {
    // Wird einmal vor allen Tests ausgeführt
}

void KasseTest::cleanupTestCase() {
    // Wird einmal nach allen Tests ausgeführt
}

void KasseTest::init() {
    // Wird vor jedem Test ausgeführt
}

void KasseTest::cleanup() {
    // Wird nach jedem Test ausgeführt
}

void KasseTest::testInitialState() {
    Kasse kasse;
    QCOMPARE(kasse.kassenstand_abfragen(), 0.0f);
    QCOMPARE(kasse.kasse_voll_, false);
}

void KasseTest::testFuellen() {
    Kasse kasse;
    kasse.fuellen();
    QCOMPARE(kasse.kasse_voll_, true);
}

void KasseTest::testLeeren() {
    Kasse kasse;
    kasse.fuellen(); // First fill the cash register
    kasse.leeren();
    QCOMPARE(kasse.kasse_voll_, false);
}

void KasseTest::testKassenstandAbfragen() {
    Kasse kasse;
    QCOMPARE(kasse.kassenstand_abfragen(), 0.0f);
}

QTEST_MAIN(KasseTest)

