#ifndef TST_UNITTEST_AKTOREN_H
#define TST_UNITTEST_AKTOREN_H



#include <QtTest>
#include "../../hii/aktoren.h"

//Die Verwendung einer Mock-Klasse (MockAktor) ist notwendig,
//um die virtuelle Methode regeln zu testen. Die Mock-Klasse überschreibt die Methode regeln,
//um festzustellen, ob sie aufgerufen wurde

class MockAktor : public aktoren {
public:
    MockAktor() : regelnCalled(false) {}

    void regeln() override {
        regelnCalled = true;
    }

    bool regelnCalled;
};

class AktorenTest : public QObject {
    Q_OBJECT

private slots:
    void initTestCase();     // Wird einmal zu Beginn ausgeführt
    void cleanupTestCase();  // Wird einmal am Ende ausgeführt
    void init();             // Wird vor jedem Test ausgeführt
    void cleanup();          // Wird nach jedem Test ausgeführt

    void testInitialState();
    void testRegeln();
};
#endif // TST_UNITTEST_AKTOREN_H
