#include "tst_unittest_elektromagnetischersensor.h"
#include <QtTest>

void ElektromagnetischerSensorTest::initTestCase() {
    // Wird einmal vor allen Tests ausgeführt
}

void ElektromagnetischerSensorTest::cleanupTestCase() {
    // Wird einmal nach allen Tests ausgeführt
}

void ElektromagnetischerSensorTest::init() {
    // Wird vor jedem Test ausgeführt
}

void ElektromagnetischerSensorTest::cleanup() {
    // Wird nach jedem Test ausgeführt
}

void ElektromagnetischerSensorTest::testInitialState() {
    MagnetischerFlussdichte flussdichte(0.1);
    QCOMPARE(flussdichte.getWert(), 0.1);
}

void ElektromagnetischerSensorTest::testErkenneMuenze() {
    ElektromagnetischerSensor sensor;
    MagnetischerFlussdichte flussdichte1(0.6);
    MagnetischerFlussdichte flussdichte2(0.4);

    QCOMPARE(sensor.erkenneMuenze(flussdichte1), 1);
    QCOMPARE(sensor.erkenneMuenze(flussdichte2), 0);
}

void ElektromagnetischerSensorTest::testErkennElektro_Magneten() {
    ElektromagnetischerSensor sensor;
    MagnetischerFlussdichte flussdichte1(1.2);
    MagnetischerFlussdichte flussdichte2(0.8);

    QCOMPARE(sensor.erkennElektro_Magneten(flussdichte1), 1);
    QCOMPARE(sensor.erkennElektro_Magneten(flussdichte2), 0);
}

QTEST_MAIN(ElektromagnetischerSensorTest)

