#include "tst_unittest_gewichtssensor.h"
#include <QtTest>


void GewichtssensorTest::initTestCase() {
    // Wird einmal vor allen Tests ausgeführt
}

void GewichtssensorTest::cleanupTestCase() {
    // Wird einmal nach allen Tests ausgeführt
}

void GewichtssensorTest::init() {
    // Wird vor jedem Test ausgeführt
}

void GewichtssensorTest::cleanup() {
    // Wird nach jedem Test ausgeführt
}

void GewichtssensorTest::testInitialState() {
    Gewichtssensor sensor;
    QCOMPARE(sensor.getAktuellesGewicht(), 200);
    QCOMPARE(sensor.zeigeGewicht(), 200);
    QCOMPARE(sensor.istRamenSchuesselErkannt(), true);
}

void GewichtssensorTest::testZeigeGewicht() {
    Gewichtssensor sensor;
    QCOMPARE(sensor.zeigeGewicht(), 200);
}

void GewichtssensorTest::testIstRamenSchuesselErkannt() {
    Gewichtssensor sensor;
    sensor.setzeGewichtsschwelle(100);
    QCOMPARE(sensor.istRamenSchuesselErkannt(), true);

    sensor.setzeGewichtsschwelle(250);
    QCOMPARE(sensor.istRamenSchuesselErkannt(), false);
}

void GewichtssensorTest::testSetzeGewichtsschwelle() {
    Gewichtssensor sensor;
    sensor.setzeGewichtsschwelle(150);
    QCOMPARE(sensor.istRamenSchuesselErkannt(), true);
}

void GewichtssensorTest::testGetAktuellesGewicht() {
    Gewichtssensor sensor;
    QCOMPARE(sensor.getAktuellesGewicht(), 200);
}

QTEST_MAIN(GewichtssensorTest)
